;// this is the animation for rotating a box     
create_wireframe_box:       
    PUSH HL;HL holds the place of the cube_struct
    call allocate_ram;it returns in IX
    POP  HL
    bit  0,A \ jp  nz,ram_alloc_error    
    ;call erase_my_ram_space;as macrodie doesn't erase the ram space i have to clear it 
                           ;because of previous vars stored at that place
    call decode_structure     ;now its need that i must create the cube     
    
    ;PUSH HL
    ;PUSH IX
    call deallocate_ram
    ;POP  HL;place where are the coords
    ;POP  IX
    bit  0,A \ jp  nz,ram_dealloc_error
    LD   B,0;no error
    RET   






;the coords must be in this order and in ram
;coords .db $00, $00, $00 vertice 1 
;       .db $00, $00, $00 vertice 2
;       .db $00, $00, $00 vertice 3
;       .db $00, $00, $00 vertice 4
;       .db $00, $00, $00 vertice 5
;       .db $00, $00, $00 vertice 6
;       .db $00, $00, $00 vertice 7
;       .db $00, $00, $00 vertice 8
;            X    Y    Z


;               
;                Y
;               /\
;                |
;                |
;                |
;                |
;                |
;                |________________\  X
;               /                 /
;             /
;           /
;         /
;      |/_
;     Z
;

; 
;                     
;                   4  _ _ _ _ 3                
;                  /|        /|               
;                /  |       / |
;             8 /_ _|_ _ _/ 7 |
;              |    |     |   |
;              |    |     |   | 
;              |   1|_ _ _|_ _|2 
;              |   /      |  /
;              |  /       | /
;              |/_ _ _ _ _|/
;              5          6

u_create_wireframe_box:
decode_structure:
;translation of the struct
;x,y,z center; x-diference , y diference , z diference ; ang_x , ang_y , ang_z ; distortion , distance
;0,1,2          3              4              5              6     7      8        9          10


;the place for the struct comes in HL
   PUSH IX
   PUSH HL \ POP IX;store the value of HL in IX
   LD   A,( IX + 3 );get the x diference 
   SRA  A;divide it by two
;now create the object coords
   POP  IX
   PUSH IX \ PUSH HL

   
   LD   B,(HL);get the x center
   LD   C,A
   LD   A,B
   SUB  C
   LD   ( IX + CUBE ),A     ; 
   LD   ( IX + CUBE + 9 ),A ;
   LD   ( IX + CUBE + 12 ),A;
   LD   ( IX + CUBE + 21 ),A;left side x coords created
   LD   A,B
   ADD  A,C;get the right side x-coords
   LD   ( IX + CUBE + 3 ),A
   LD   ( IX + CUBE + 6 ),A
   LD   ( IX + CUBE + 15 ),A
   LD   ( IX + CUBE + 18 ),A;right side x coords created
   ;x coords done now y coords
   INC  HL;lets do the next one
   LD   B,(HL)
   LD   A,B
   PUSH IX
   PUSH HL
   POP  IX
   LD   C,(IX + 3)
   SRA  C;divide it by 2
   POP  IX;restore IX
   SUB  C;
   LD   ( IX + CUBE + 1 ),A
   LD   ( IX + CUBE + 4 ),A
   LD   ( IX + CUBE + 13 ),A
   LD   ( IX + CUBE + 16 ),A
   LD   A,B
   ADD  A,C
   LD   ( IX + CUBE + 7 ),A
   LD   ( IX + CUBE + 10 ),A
   LD   ( IX + CUBE + 19 ),A
   LD   ( IX + CUBE + 22 ),A
   INC  HL
   LD   B,(HL);get the z center
   LD   A,B
   PUSH IX
   PUSH HL
   POP  IX
   LD   C,(IX + 3);get the z center
   POP  IX
   SRA  C;divide it by two
   SUB  C
   LD   ( IX + CUBE + 11),A
   LD   ( IX + CUBE + 8 ),A
   LD   ( IX + CUBE + 5 ),A
   LD   ( IX + CUBE + 2 ),A
   LD   A,B
   ADD  A,C
   LD   ( IX + CUBE + 23 ),A
   LD   ( IX + CUBE + 20 ),A
   LD   ( IX + CUBE + 14 ),A
   LD   ( IX + CUBE + 17 ),A
   ;cube created around the center   
   POP  HL
   PUSH HL \ POP IX
   LD   A,( IX + 6 )
   LD   B,( IX + 7 )
   LD   C,( IX + 8 )
   LD   D,( IX + 9 );distortion
   LD   E,( IX + 10 );distance
   POP  IX
   LD   ( IX + angle_x ),A
   LD   ( IX + angle_y ),B
   LD   ( IX + angle_z ),C;object created
   LD   ( IX + distortion ),D
   LD   ( IX + dist ),E
   ;now lets create it on the specified angle
   ;lets check the angles we do not need to calculate unspecified angles
   ;this is only for speeding the things a little bit
     
   call  calc_camera_y_around_x
   call  calc_camera_z_around_x
   call  calc_camera_z_around_other
   call  calc_camera_x
   call  calc_camera_x_around_other
;now its time for calculating the 8 points around the specified angle
   PUSH  IX
   POP   HL
   LD    DE,CUBE
   ADD   HL,DE
   XOR   A
   LD    (IX + p),A
   LD    (IX + store_coords),A
calculate_box_coords:   
   ;LD    A,(IX + p)
   LD    B,A
   XOR   8
   jp    z,box_coords_have_been_calculated
;now callculate the WorkCubes   
   PUSH  BC
      
   PUSH  HL
   PUSH  HL
   call  calc_WorkCube.x
   POP   HL
   INC   HL
   PUSH  HL
   PUSH  HL
   call  calc_WorkCube.y
   POP   HL
   INC   HL
   PUSH  HL
   PUSH  HL
   call  calc_WorkCube.z
   POP   HL
   INC   HL;point to the next
   PUSH  HL
   call  rotate_around_y   
   call  rotate_around_x
   call  rotate_around_z
   LD    E,(IX + store_coords)
   LD    D,0
   LD    A,E
   INC   A \ INC  A
   LD    (IX + store_coords),A;save incremented
   LD    HL,SP_CUBE
   PUSH  DE
   PUSH  IX 
   POP DE
   ADD   HL,DE
   POP   DE
   ADD   HL,DE
   PUSH  HL
   PUSH  HL
   call  SP_CUBE_x
   POP   HL
   INC   HL
   PUSH  HL
   call  SP_CUBE_y
   POP   HL
   
   POP   AF
   
   ;LD    A,(IX + p)
   INC   A
   ;LD   (IX + p),A
   jp   calculate_box_coords
     
box_coords_have_been_calculated:
    ;now its time for drawing the cube
    LD   A,(IX + animated_mode);let me see if this is in animated mode
    OR   A;if it is do not draw the cube
    jp   nz,get_back_box
    call draw_SP_CUBE 
get_back_box:    
    RET;go back          
   