;// this is the animation for rotating a cube       
create_wireframe_cube:       
    PUSH HL;HL holds the place of the cube_struct
    call allocate_ram;it returns in IX
    POP  HL
    bit  0,A \ jp  nz,ram_alloc_error    
    ;call erase_my_ram_space;as macrodie doesn't erase the ram space i have to clear it **
                           ;because of previous vars stored at that place
    call decode_struct     ;now its need that i must create the cube     
                           ; ** maybe this is not necessary and could increase the speed of the system
    ;PUSH HL               ;not necessary the ram will be dealocate and erased
    ;PUSH IX
    call deallocate_ram
    ;POP  HL;place where are the coords
    ;POP  IX
    bit  0,A \ jp  nz,ram_dealloc_error
    ;XOR  A     ;THIS WILL TAKE ONE MORE CICLE OF CLOCK TO COMPLETE
    ;LD   B,A   ; 
    LD    B,0
    RET   






;the coords must be in this order and in ram
;coords .db $00, $00, $00 vertice 1 
;       .db $00, $00, $00 vertice 2
;       .db $00, $00, $00 vertice 3
;       .db $00, $00, $00 vertice 4
;       .db $00, $00, $00 vertice 5
;       .db $00, $00, $00 vertice 6
;       .db $00, $00, $00 vertice 7
;       .db $00, $00, $00 vertice 8
;            X    Y    Z


;               
;                Y
;               /\
;                |
;                |
;                |
;                |
;                |
;                |________________\  X
;               /                 /
;             /
;           /
;         /
;      |/_
;     Z
;


; 
;                     
;                   4  _ _ _ _ 3                
;                  /|        /|               
;                /  |       / |
;             8 /_ _|_ _ _/ 7 |
;              |    |     |   |
;              |    |     |   | 
;              |   1|_ _ _|_ _|2 
;              |   /      |  /
;              |  /       | /
;              |/_ _ _ _ _|/
;              5          6

u_create_wireframe_cube:
decode_struct:
;translation of the struct
;  cube center , distance between 2 vertices , angle to rotate , distortion,distance from the object      

;first i will create the dawn cube and store its coords on CUBE then store the angle and distortion and only then rotate it

;cube struct
; (x,y,z) cube center ; distance between two vertices ; angle_x ; angle_y ; angle_z ; distortion ;distance between us and the object

;the place for the struct comes in HL
   PUSH IX
   PUSH HL \ POP IX;store the value of HL in IX
   LD   A,( IX + 3 );get the vertice diference 
   SRA  A;divide it by two
;now create the object coords
   POP  IX
   PUSH IX \ PUSH HL

   
   LD   B,(HL);get the x center
   LD   C,A
   LD   A,B
   SUB  C
   LD   ( IX + CUBE ),A     ; 
   LD   ( IX + CUBE + 9 ),A ;
   LD   ( IX + CUBE + 12 ),A;
   LD   ( IX + CUBE + 21 ),A;left side x coords created
   LD   A,B
   ADD  A,C;get the right side x-coords
   LD   ( IX + CUBE + 3 ),A
   LD   ( IX + CUBE + 6 ),A
   LD   ( IX + CUBE + 15 ),A
   LD   ( IX + CUBE + 18 ),A;right side x coords created
   ;x coords done now y coords
   INC  HL;lets do the next one
   LD   B,(HL)
   LD   A,B
   SUB  C
   LD   ( IX + CUBE + 1 ),A
   LD   ( IX + CUBE + 4 ),A
   LD   ( IX + CUBE + 13 ),A
   LD   ( IX + CUBE + 16 ),A
   LD   A,B
   ADD  A,C
   LD   ( IX + CUBE + 7 ),A
   LD   ( IX + CUBE + 10 ),A
   LD   ( IX + CUBE + 19 ),A
   LD   ( IX + CUBE + 22 ),A
   INC  HL
   LD   B,(HL);get the z center
   LD   A,B
   SUB  C
   LD   ( IX + CUBE + 11),A
   LD   ( IX + CUBE + 8 ),A
   LD   ( IX + CUBE + 5 ),A
   LD   ( IX + CUBE + 2 ),A
   LD   A,B
   ADD  A,C
   LD   ( IX + CUBE + 23 ),A
   LD   ( IX + CUBE + 20 ),A
   LD   ( IX + CUBE + 14 ),A
   LD   ( IX + CUBE + 17 ),A
   ;cube created around the center   
   POP  HL
   PUSH HL \ POP IX
   LD   A,( IX + 4 )
   LD   B,( IX + 5 )
   LD   C,( IX + 6 )
   LD   D,( IX + 7 );distortion
   LD   E,( IX + 8 );distance
   POP  IX
   LD   ( IX + angle_x ),A
   LD   ( IX + angle_y ),B
   LD   ( IX + angle_z ),C;object created
   LD   ( IX + distortion ),D
   LD   ( IX + dist ),E
   ;now lets create it on the specified angle
   ;lets check the angles we do not need to calculate unspecified angles
   ;this is only for speeding the things a little bit
     
   call  calc_camera_y_around_x;in order for making this we will use 17 cicles of clock eatch time so why not put it in a easy way
   call  calc_camera_z_around_x
   call  calc_camera_z_around_other
   call  calc_camera_x
   call  calc_camera_x_around_other
   ;call  calc_cameras;using it in this way we only will use 17 cicles once
;now its time for calculating the 8 points around the specified angle
   PUSH  IX
   POP   HL
   LD    DE,CUBE
   ADD   HL,DE
   XOR   A
   LD    (IX + p),A
   LD    (IX + store_coords),A
   ;well for putting it a litle faster i will use an register
calculate_cube_coords:
   ;LD    A,(IX + p);takes 19 cycles for completing
   LD    B,A
   XOR   8
   jp    z,cube_coords_have_been_calculated;jp is fastest
;now callculate the WorkCubes   
   PUSH  BC;save the register as the register's of the CPU are hight speed 
   
   PUSH  HL
   PUSH  HL
   call  calc_WorkCube.x
   POP   HL
   INC   HL
   PUSH  HL
   PUSH  HL
   call  calc_WorkCube.y
   POP   HL
   INC   HL
   PUSH  HL
   PUSH  HL
   call  calc_WorkCube.z
   POP   HL
   INC   HL;point to the next
   PUSH  HL
   call  rotate_around_y   
   call  rotate_around_x
   call  rotate_around_z
   LD    E,(IX + store_coords)
   LD    D,0
   LD    A,E
   INC   A \ INC  A
   LD    (IX + store_coords),A;save incremented
   LD    HL,SP_CUBE
   PUSH  DE
   PUSH  IX 
   POP DE
   ADD   HL,DE
   POP   DE
   ADD   HL,DE
   PUSH  HL
   PUSH  HL
   call  SP_CUBE_x
   POP   HL
   INC   HL
   PUSH  HL
   call  SP_CUBE_y
   POP   HL
   
   POP   AF;the number of points register
   ;LD    A,(IX + p);this will be a litle slow so try to put it faster
   INC   A
   ;LD   (IX + p),A ;well i have reduced from 57 cicles of CPU to only 21
   jp   calculate_cube_coords;jp is fastest
     
cube_coords_have_been_calculated:
    ;now its time for drawing the cube
    LD   A,(IX + animated_mode);let me see if this is in animated mode
    OR   A;if it is do not draw the cube
    jp   nz,get_back
    call draw_SP_CUBE 
get_back:    
    RET;go back          
   
   
   
create_animated_cube:
    ;well for creating an animated cube we must know its 
    PUSH HL;HL holds the place of the cube_struct
    call allocate_ram;it returns in IX
    POP  HL
    CP   1 \ jp  z,ram_alloc_error    
    call erase_my_ram_space;as macrodie doesn't erase the ram space i have to clear it 
                          ;because of previous vars stored at that place
                           ;before  create the cube i will activate the animation flag mode
    LD   A,1
    LD   (IX + animated_mode),A;activate the flag                       
    PUSH HL                ;i save the struct for futher usage
    call decode_struct     ;now its need that i must create the cube     
    POP  HL                ;restore the address of the struct now its time 
                           ;to convert the 6 textures for the 6 diferent faces
    call solid_animation    ;now i will animate it
    
    PUSH HL
    PUSH IX
    call deallocate_ram
    POP  HL;place where are the coords
    POP  IX
    CP   1 \ jp  z,ram_dealloc_error
    XOR  A;no error
    LD   B,A
    RET
;the concept-> display all the faces with the points on directive     
;
;another way is to find the front part and then when drawing the others we stop at his area
;for make this we must get the face with bigger area
;there are another ways witch are more power spensive and as they need a bigger calculation power i will not give them
; as an option here that speeds is an important thing
solid_animation:
    RET













draw_SP_CUBE:
;we first draw the 2 z planes and then we draw the connection
    PUSH IX \ POP HL
    LD   DE,SP_CUBE
    ADD  HL,DE;get the address of the points
    PUSH HL
    PUSH HL
    call draw_plane
    POP  HL
    PUSH HL
    LD   DE,8
    ADD  HL,DE
    PUSH HL
    call draw_plane;draw second plane
    ;now i must draw the connections
    ;POP  HL ;well for speed this will not be needed
    ;PUSH HL
    call draw_links
    RET

draw_plane:
    POP BC;the return address
    POP HL;the address of the 8 coords that make the plane
    PUSH IX
    PUSH HL \ POP IX
    PUSH BC
    
    LD   B,( IX + 0 );1
    LD   C,( IX + 1 );1
    LD   D,( IX + 2 );2
    LD   E,( IX + 3 );2
    LD   H,2
    PUSH BC \ PUSH HL \ PUSH IX
    bcall _ILine
    POP  IX
    POP  HL \ POP  BC
    LD   D,( IX + 6 );4
    LD   E,( IX + 7 );4
    PUSH BC \ PUSH HL \ PUSH IX
    bcall _ILine
    POP  IX
    POP  HL \ POP  BC

    ;LD   B,2
    LD   B,( IX + 4 );3
    LD   C,( IX + 5 );3
    LD   D,( IX + 2 );2
    LD   E,( IX + 3 );2
    LD   H,2
    PUSH BC \ PUSH HL \ PUSH IX
    bcall _ILine
    POP  IX
    POP  HL \ POP  BC
    LD   D,( IX + 6 );4
    LD   E,( IX + 7 );4
    PUSH BC \ PUSH HL \ PUSH IX
    bcall _ILine
    POP  IX
    POP  HL \ POP  BC
    ;the 4 lines have been draw
    POP  BC ;restoring BC
    POP  IX ;restoring IX
    PUSH BC
    RET;go back
    
draw_links:
    POP   BC
    POP   HL
    PUSH  IX
    PUSH  HL
    PUSH  BC
    LD    B,4
    PUSH  HL \ POP  IX
_draw_4_links:
    PUSH  BC
    LD    B,(IX + 0 );X
    LD    C,(IX + 1 );Y
    LD    D,(IX + 8 );X
    LD    E,(IX + 9 );Y
    LD    H,2
    PUSH  IX
    bcall _ILine
    POP   IX
    INC   IX;Y
    INC   IX;X
    POP   BC
    DJNZ  _draw_4_links
    POP   BC
    POP   HL
    POP   IX
    PUSH  BC
    RET    


   
      
            
.end    
