#include "ti83plus.inc"
#include "macrodie.inc"
#include "directx.inc"
.org $9D95
;structure for one macrodie program
    RET;for preventing ti-os to execute it 
    jr start
    LD   BC,end_of_vars - start_of_vars;this reports to macrodie the size of the variables
icon:;icon of the prog to disp on the folder
;16 , 16
.db %00000000, %00000000
.db %00000011, %10000000
.db %00000010, %01100000
.db %00000010, %00110000
.db %00000010, %00001000
.db %00001111, %00001000
.db %00011001, %00001100;you should edit this to your icon
.db %00000001, %10000100
.db %00000000, %10000100
.db %00110000, %10110000
.db %00100000, %10001111
.db %00000001, %10000000
.db %00000111, %00000000
.db %00011011, %10000000
.db %00011110, %10001000
.db %00000000, %10001100
    
start:;start of code for macrodie 
    LD   A,(background_program_status)
    CP   1 \ jr   z,program_already_added
    LD   A,1
    LD   (background_program_status),A
    LD   HL,background_task
    xor  a;macrodie page
    invoke( ADD_program_to_background )
;===========================================
;======== Your Code Begins Here ============
;============================================      
program_already_added:;main control begins here
    xor   a
    invoke( create_default_pasta );criamos uma pasta de servico
    xor   a
    invoke( mouse2 );call mouse  
looping_return:
    xor   a
    invoke( loop2 );call mouse loop don't affect screen unless modification of coords
    bit   0,A      ;this is for handling the mouse and the draw at the same time
    PUSH  AF
    call  try_to_animate_object
    POP   AF
    jr    z,looping_return
    xor   a
    invoke( window_verif_coords )
    LD    A,B
    CP    1 \ jr  z,prog_finished
minimizate_window:
    XOR  A
    LD   (activ_task),A
    LD   (close_task),A ;ordem ao windows para fechar task activa
    LD   (screen),A
    LD   (animar_flag),A
    RET;return to macrodie
    

prog_finished:
    LD   A,(activ_task)
    LD   (close_task),A ;ordem ao windows para fechar task activa   
    XOR  A
    LD   (activ_task),A
    LD   (screen),A
    LD   (animar_flag),A
    RET  ;volto ao windows

;// here starts my code
try_to_animate_object:    
    LD    A,(library_state)
    OR    A \ jr  nz,start_animation
    LD    A,1
    LD    (library_state),A
    bcall _ZeroOP1
    LD    HL,library_name
    bcall _Mov9ToOP1
    bcall _FindApp
    jr    c,error_library
    LD    (library_page),A
start_animation:
    LD    A,(library_page)
    LD    HL,piramid_struct
    set   bufferOnly, (IY + plotFlag3);draw to buffer only 
    PUSH  AF
    
    invoke( create_wireframe_piramid );this will create it
    
    POP   AF
    PUSH  AF
    
    LD    HL,cube_struct
    invoke( create_wireframe_cube );display it
    
    
    xor   a
    invoke( fastcopy );display it
    set   bufferOnly, (IY + plotFlag3);draw to buffer only 
    POP   AF
    PUSH  AF
    LD    HL,piramid_struct
    invoke( create_wireframe_piramid );erase it yap but i have to put here the daw coords
    POP   AF
    LD    HL,cube_struct
    invoke( create_wireframe_cube );erase it
    
    LD    A,(piramid_struct+6);points to angle
    ADD   A,8;two times faster
    LD    (piramid_struct + 6),A;updates it
    LD    (piramid_struct + 5),A
    LD    (piramid_struct + 7),A
    LD    (cube_struct + 5),A
    LD    (cube_struct + 6),A
    LD    (cube_struct + 4),A
    RET;lets try around y





error_library:
    set  textwrite,(IY+SGRFLAGS)
    LD   HL,library_error
    LD   DE,14*256+4 
    LD   (_penCol),DE
    bcall _VPutS
    LD   DE,21*256+4 
    LD   (_penCol),DE
    bcall _VPutS
    LD   DE,28*256+4 
    LD   (_penCol),DE
    bcall _VPutS
    RET


;====================================================
;==== This is what your program execute allways =====
;====================================================
;this is the routine that your program is executing on idle
;the code in here shouldn't access to the screen not even the keyboard
background_task:
     RET
     
;=======================================================
;==== This area is reserverd for your programs vars ====
;======================================================= 
start_of_vars:
background_program_status .db 0 ;this reports to the main code routine if the program have been already added to background
;do not change this variable
;======================================================
;============ start of your variables field ===========
;======================================================
library_state .db 0
library_page  .db 0
library_name  .db 14h,"DIRECTX1",0;search for library directx1
library_error  .db "Error the library 'DIRECTX1'",0
               .db " isn't installed!!!"
               .db " Please install it!",0
;// i will create for now a cube on screen and try to rotate it
;( x , y , z ) , hight,V1-V2 ,ang_x,ang_y,ang_z,distortion,distance
piramid_struct:    .db 0,0,0,12,12,0,0,0,80,50;bigger distance   
cube_struct:       .db 0,0,0,16,0,0,0,80,50

end_of_vars:
;======================================================
;=========== end of your variables field ==============
;======================================================